.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

.code
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
GetPercentJJ1_s:
GPJ001	REAL10 0.01
GetPercentJJ1 proc source:DWORD, percent:DWORD
;		ffree st(7)
		push eax
	fld GPJ001	; mul source by 0.01, i.e. divide by 100
	fimul dword ptr [esp+8]	; load source integer
	fimul dword ptr [esp+12]	; multiply 1% by required percentage
	fistp dword ptr [esp]	; store result on stack
	pop eax	; return in eax
	ret 8
GetPercentJJ1 endp
GetPercentJJ1_e:

GetPercentJJ2_s:
GPJ002	REAL8 0.01
GetPercentJJ2 proc source:DWORD, percent:DWORD
		ffree st(7)
		push eax
	fild dword ptr [esp+8]	; load source integer
	fmul GPJ002	; multiply with 0.01, i.e. divide source by 100
	fimul dword ptr [esp+12]	; multiply 1% by required percentage
	fistp dword ptr [esp]	; store result on stack
	pop eax	; return in eax
	ret 8
GetPercentJJ2 endp
GetPercentJJ2_e:

GetPercentJJ3_s:
GetPercentJJ3 proc source:DWORD, percent:DWORD
		mov eax, [esp+4]	; source
		imul dword ptr [esp+8]	; percent
		push 100
		idiv dword ptr [esp]
		pop edx
		ret 8
GetPercentJJ3 endp
GetPercentJJ3_e:

GetPercentJJ4_s:
GPJ004	REAL8 0.01
GetPercentJJ4 proc source:DWORD, percent:DWORD
		mov eax, [esp+4]	; source
		imul dword ptr [esp+8]	; percent
		push eax
	fild dword ptr [esp]	; load source integer
	fmul GPJ004	; divide source by 100
	fistp dword ptr [esp]	; store result on stack
	pop eax	; return in eax
		ret 8
GetPercentJJ4 endp
GetPercentJJ4_e:

GetPercentSSE_s:
GPJ005	REAL8 0.01
GetPercentSSE proc source:DWORD, percent:DWORD
		cvtsi2sd xmm0, dword ptr [esp+4]		; source
		cvtsi2sd xmm1, dword ptr [esp+8]		; percent
		mulsd xmm0, xmm1
		mulsd xmm0, GPJ005		; divide source by 100
		cvttsd2si eax, xmm0
		ret 8
GetPercentSSE endp
GetPercentSSE_e:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
start:	push 1
	call ShowCpu	; print brand string and SSE level

;		invoke GetPercentSSE, 222222222, 50
;		print str$(eax), " - should be 111111111", 13, 10

	SleepMs =	50	; test if anything changes when changing this
	LOOP_COUNT =	5000000	; One Mio would be a typical value
	REPEAT 2
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke GetPercent, 12345678, 55
		counter_end
		print str$(eax), 9, "cycles for GetPercent", 13, 10
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke GetPercentJJ1, 12345678, 55
		counter_end
		print str$(eax), 9, "cycles for GetPercentJJ1", 13, 10
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke GetPercentJJ2, 12345678, 55
		counter_end
		print str$(eax), 9, "cycles for GetPercentJJ2", 13, 10
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke GetPercentJJ3, 12345678, 55
		counter_end
		print str$(eax), 9, "cycles for GetPercentJJ3", 13, 10
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke GetPercentJJ4, 12345678, 55
		counter_end
		print str$(eax), 9, "cycles for GetPercentJJ4", 13, 10
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke GetPercentSSE, 12345678, 55
		counter_end
		print str$(eax), 9, "cycles for GetPercentSSE", 13, 10
		print chr$(13, 10)
	ENDM
	print "Code sizes:", 13, 10
	mov eax, GetPercentJJ1_e
	sub eax, GetPercentJJ1_s
	print str$(eax), 9, "for GetPercentJJ1", 13, 10
	mov eax, GetPercentJJ2_e
	sub eax, GetPercentJJ2_s
	print str$(eax), 9, "for GetPercentJJ2", 13, 10
	mov eax, GetPercentJJ3_e
	sub eax, GetPercentJJ3_s
	print str$(eax), 9, "for GetPercentJJ3", 13, 10
	mov eax, GetPercentJJ4_e
	sub eax, GetPercentJJ4_s
	print str$(eax), 9, "for GetPercentJJ4", 13, 10
	mov eax, GetPercentSSE_e
	sub eax, GetPercentSSE_s
	print str$(eax), 9, "for GetPercentSSE", 13, 10
	inkey chr$(13, 10, "--- ok ---", 13)
	exit

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]